﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDG2015HierarchyCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        List<DataRecord> recordList = new List<DataRecord>();        
        private void RecordDepthBtn_Click(object sender, RoutedEventArgs e)
        {
            DataRecord DR = XDG1.Records[0] as DataRecord;

            //Null parameter at first, to start at XamDataGrid level and get all records.
            //This can also be used to get all records of a specified depth from a particular record.
            GetRecordsAtDepth(null, 4);

            var x = recordList;
        }
        
        public void GetRecordsAtDepth(DataRecord DR, int nestedDepth)
        {
            if (recordList.Where(e => e.NestingDepth != nestedDepth).Count() != 0)
            {
                recordList.Clear();
            }

            if (DR != null)
            {              
                if (DR.NestingDepth == nestedDepth)
                {
                    recordList.Add(DR);
                }
                else
                {
                    if (DR.HasChildren)
                    {
                        foreach (ExpandableFieldRecord EFR in DR.ChildRecords)
                        {
                            foreach (DataRecord childRecord in EFR.ViewableChildRecords)
                            {
                                GetRecordsAtDepth(childRecord, nestedDepth);
                            }
                        }
                    }
                }
            }
            else if(DR == null && nestedDepth != 0)
            {
                foreach (DataRecord record in XDG1.Records)
                {
                    GetRecordsAtDepth(record, nestedDepth);
                }                
            }

            //DR != null and nestedDepth = 0. Top Level Records.
            else
            {
                foreach (DataRecord record in XDG1.Records)
                {
                    recordList.Add(record);
                }               
            }
        }
    }
}
