﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDG2015HierarchyCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleParentData> Data { get; set; }

        string[] names = "Andrew;Alex;Jen;Steve;Eric;Ed;Joe;Valerie;Pamela".Split(';');
        string[] childNames = "Jessica;Tim;Robert;Charlie;Jamie;Zoe".Split(';');


        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleParentData>();

            for (int i = 0; i < names.Length; i++)
            {              
                Data.Add(new SampleParentData()
                {
                    ID = (i+1),
                    Name = names[i]
                });
            }

            foreach (SampleParentData SPD in Data)
            {
                for (int i = 0; i < 2; i++)
                {
                    SampleChildData SCD = new SampleChildData();
                    SCD.NextChild = new ObservableCollection<SampleChildData>();

                    for (int j = 0; j < 2; j++)
                    {
                        SCD.NextChild.Add(new SampleChildData()
                        {
                            ChildID = j,
                            ChildName = childNames[r.Next(childNames.Length)]
                        });                        
                    }

                    SCD.ChildName = childNames[r.Next(childNames.Length)];
                    SCD.ChildID = i;

                    SPD.Children.Add(SCD);
                }
            }            
        }
    }

    public class SampleParentData
    {
        public int ID { get; set; }
        public string Name { get; set; }

        public ObservableCollection<SampleChildData> Children { get; set; }        

        Random r = new Random();
        public SampleParentData()
        {
            Children = new ObservableCollection<SampleChildData>();           
        }
    }

    public class SampleChildData
    {
        public int ChildID { get; set; }
        public string ChildName { get; set; }

        public ObservableCollection<SampleChildData> NextChild { get; set; }        
    }  
}
